#include <vector>

#include "light.h"
#include "constants.h"

namespace kek {

Light::Light(glm::vec3 color) {
	this->color = color;
}

Light::~Light() {

}

PointLight::PointLight(glm::vec3 color, float constantFalloff, float linearFalloff, float quadraticFalloff): Light(color) {
	this->constant = constantFalloff;
	this->linear = linearFalloff;
	this->quadratic = quadraticFalloff;
}

PointLight::~PointLight() {

}

LightType PointLight::getType() {
	return LightType::POINT;
}

LightList::LightList() {
	point = std::vector<PointLight *>();
	//directional = std::vector<DirectionalLight *>();
	//spot = std::vector<SpotLight *>();
}

void LightList::add(Light *light) {
	switch(light->getType()) {
		case LightType::POINT: point.push_back((PointLight *) light); break;
		//case LightType::DIRECTIONAL: directional.push_back((DirectionalLight *) light); break;
		//case LightType::SPOT: spot.push_back((SpotLight *) light); break;
	}
}

}
