#pragma once

#include <glm/glm.hpp>
#include <vector>

#include "object.h"

namespace kek {

enum class LightType {
	POINT,
	DIRECTIONAL,
	SPOT
};

class Light {

public:
	glm::vec3 color;

	Light(glm::vec3 color);

	virtual ~Light();

	virtual LightType getType() = 0;

};

class PointLight: public Light, public DefaultObject {

public:
	float constant, linear, quadratic;

	PointLight(glm::vec3 color, float constant, float linear, float quadratic);

	~PointLight();

	LightType getType();

};

class LightList {

public:
	std::vector<PointLight *> point;
	//std::vector<DirectionalLight *> directional;
	//std::vector<SpotLight *> spot;

	LightList();

	void add(Light *light);

};

}
